<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="es">
<head>
<!-- Generated by javadoc (1.8.0_191) on Fri Mar 15 18:21:06 CST 2019 -->
<title>LispInterpreterView</title>
<meta name="date" content="2019-03-15">
<link rel="stylesheet" type="text/css" href="stylesheet.css" title="Style">
<script type="text/javascript" src="script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="LispInterpreterView";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":9,"i2":10,"i3":9,"i4":9,"i5":9,"i6":9,"i7":9,"i8":9,"i9":9,"i10":9,"i11":9,"i12":9,"i13":9,"i14":9,"i15":9,"i16":10,"i17":9,"i18":9,"i19":9,"i20":9,"i21":9,"i22":9,"i23":9,"i24":9,"i25":9,"i26":10,"i27":9,"i28":10,"i29":9,"i30":9,"i31":10,"i32":10,"i33":9,"i34":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="deprecated-list.html">Deprecated</a></li>
<li><a href="index-files/index-1.html">Index</a></li>
<li><a href="help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="Main.html" title="class in &lt;Unnamed&gt;"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="index.html?LispInterpreterView.html" target="_top">Frames</a></li>
<li><a href="LispInterpreterView.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<h2 title="Class LispInterpreterView" class="title">Class LispInterpreterView</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>LispInterpreterView</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">LispInterpreterView</span>
extends java.lang.Object</pre>
<div class="block">This class's purpose is to show the UI and execute the expressions and apply the functions in the
 program, to later show the result in a textBox implementing Swing</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>(package private) javafx.stage.FileChooser</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#fileChooser">fileChooser</a></span></code>
<div class="block">File chooser for pick the text file with the math expressions</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#funArgumentsList">funArgumentsList</a></span></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static java.util.LinkedList&lt;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#funDefinitionList">funDefinitionList</a></span></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>(package private) javafx.scene.control.TextArea</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#input">input</a></span></code>
<div class="block">TextArea for show the results</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static java.util.HashSet&lt;java.lang.String&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#keywords">keywords</a></span></code>
<div class="block">A HashSet used to store the keywords from lisp</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static <a href="MyParser.html" title="class in &lt;Unnamed&gt;">MyParser</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#myParser">myParser</a></span></code>
<div class="block">For parse</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static java.util.HashSet&lt;java.lang.String&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#numericFunctionSet">numericFunctionSet</a></span></code>
<div class="block">A hashSet to store the numericFunctionSet</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>(package private) java.lang.String</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#outputToProcess">outputToProcess</a></span></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>(package private) javafx.scene.control.TextArea</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#result">result</a></span></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="LispInterpreterView.html#LispInterpreterView--">LispInterpreterView</a></span>()</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>javafx.scene.layout.HBox</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#addHBox-javafx.stage.Stage-">addHBox</a></span>(javafx.stage.Stage&nbsp;stage)</code>
<div class="block">To return a HBox with two buttons for read file and clear TextArea</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>private static void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#addPairs-Node-Node-java.util.LinkedList-">addPairs</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;formalParamList,
        <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;actualParamList,
        java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList)</code>
<div class="block">Adds the Node of the required param for a function and the Node of the passed params tho the funArgumentsList</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>javafx.scene.layout.VBox</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#addVBox--">addVBox</a></span>()</code>
<div class="block">For add a TextArea to the screen, and show the result</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#apply-Node-Node-java.util.LinkedList-java.util.LinkedList-">apply</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;funName,
     <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;actualParamList,
     java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList,
     java.util.LinkedList&lt;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&nbsp;dList)</code>
<div class="block">applies the changes and executes the function</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#atom-Node-">atom</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</code>
<div class="block">Verifies if an specific argument passed after atom is ATOM type or not</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>private static boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#bound-java.lang.String-java.util.LinkedList-">bound</a></span>(java.lang.String&nbsp;key,
     java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList)</code>
<div class="block">Search in a Node HashMap contains a pair with a given key</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#car-Node-">car</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</code>
<div class="block">Checks if a given Node has a leftSide child.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#cdr-Node-">cdr</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</code>
<div class="block">Evaluates the rightSide child of a Node</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#cons-Node-Node-">cons</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
    <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)</code>
<div class="block">Constructs a new pair of variables from any type (ATOM_NUMBER, ATOM_LITERAL)</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#eq-Node-Node-">eq</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
  <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)</code>
<div class="block">Verifies if the value of a node is equal to the value of another node</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#evaluate-Node-java.util.LinkedList-java.util.LinkedList-">evaluate</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s,
        java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList,
        java.util.LinkedList&lt;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&nbsp;dList)</code>
<div class="block">Evaluates a node (function), both UDF´s and proper Lisp functions are evaluated and changes are made callin apply() method</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#evList-Node-java.util.LinkedList-java.util.LinkedList-">evList</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;actualParamList,
      java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList,
      java.util.LinkedList&lt;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&nbsp;dList)</code>
<div class="block">Passes the constructed expression to the evaluate() method</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>private static java.lang.String</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#getExpression-Node-">getExpression</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;root)</code>
<div class="block">Gets the expression as a String</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#getVal-java.lang.String-java.util.LinkedList-">getVal</a></span>(java.lang.String&nbsp;key,
      java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList)</code>
<div class="block">Gets a node from the funArgumentsList linkedList with an specific key provided</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#getValFromDList-java.lang.String-java.util.LinkedList-">getValFromDList</a></span>(java.lang.String&nbsp;functionName,
               java.util.LinkedList&lt;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&nbsp;dList)</code>
<div class="block">Obtains the Node that contains a function definition matching a given functionName</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#greater-Node-Node-">greater</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
       <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)</code>
<div class="block">Verifies if the value of node 1 is greater than value of node 2</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#hasSameBraces-java.lang.String-">hasSameBraces</a></span>(java.lang.String&nbsp;line)</code>
<div class="block">Verifies if an expression has the same amount of opening braces as closing braces before passing the expression
 to the execution part</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#int_-Node-">int_</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</code>
<div class="block">Evaluates if a given node is int type (creates a new Node of value T or NIL depending on wether
 it is or not an int type Node)</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>private static boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#isList-Node-">isList</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;node)</code>
<div class="block">verify if a given Node is a list</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>private static boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#isLiteralAtom-Node-">isLiteralAtom</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</code>
<div class="block">Verifies if a certain node is LiteralAtom type</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#length-Node-">length</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;node)</code>
<div class="block">Check the length of a node</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#less-Node-Node-">less</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
    <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)</code>
<div class="block">Verifies if the value of node 1 is less than value of node 2</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#minus-Node-Node-">minus</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
     <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)</code>
<div class="block">Operates a rest with the value of two NumericAtom type nodes</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#null_-Node-">null_</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</code>
<div class="block">Evaluates if a node's value is NIL type</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#numNodes-Node-">numNodes</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;node)</code>
<div class="block">Calculat the number of nodes that are childs of an specific Node</div>
</td>
</tr>
<tr id="i25" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#plus-Node-Node-">plus</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
    <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)</code>
<div class="block">Sums the value of two NumericAtom type nodes</div>
</td>
</tr>
<tr id="i26" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#printExpression-Node-">printExpression</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;root)</code>
<div class="block">Pretty printing the parse tree for top-level expression</div>
</td>
</tr>
<tr id="i27" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#quotient-Node-Node-">quotient</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
        <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)</code>
<div class="block">Operates the division between two NumericAtom type nodes</div>
</td>
</tr>
<tr id="i28" class="altColor">
<td class="colFirst"><code>private java.util.ArrayList&lt;java.lang.String&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#readFile-java.io.File-">readFile</a></span>(java.io.File&nbsp;file)</code>
<div class="block">For read a file line by line</div>
</td>
</tr>
<tr id="i29" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#remainder-Node-Node-">remainder</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
         <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)</code>
<div class="block">Operates a division between two NumericAtom type nodes and returns the reminder of the operation</div>
</td>
</tr>
<tr id="i30" class="altColor">
<td class="colFirst"><code>private static void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#removePairs-Node-Node-java.util.LinkedList-">removePairs</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;formalParamList,
           <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;actualParamList,
           java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList)</code>
<div class="block">Deletes the pairs from funArgumentsList once the function is executed</div>
</td>
</tr>
<tr id="i31" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#show-javafx.stage.Stage-">show</a></span>(javafx.stage.Stage&nbsp;stage)</code>
<div class="block">To show the JavFX UI</div>
</td>
</tr>
<tr id="i32" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#startInterpreting--">startInterpreting</a></span>()</code>
<div class="block">Interpreting the expression</div>
</td>
</tr>
<tr id="i33" class="rowColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#string_-Node-">string_</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</code>
<div class="block">Evaluates if a given node is string type (creates a new Node of value T or NIL depending on whether
 it is or not a string type Node)</div>
</td>
</tr>
<tr id="i34" class="altColor">
<td class="colFirst"><code>private static <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="LispInterpreterView.html#times-Node-Node-">times</a></span>(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
     <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)</code>
<div class="block">Multiplies two NumericAtom type nodes</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="input">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>input</h4>
<pre>javafx.scene.control.TextArea input</pre>
<div class="block">TextArea for show the results</div>
</li>
</ul>
<a name="result">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>result</h4>
<pre>javafx.scene.control.TextArea result</pre>
</li>
</ul>
<a name="outputToProcess">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>outputToProcess</h4>
<pre>java.lang.String outputToProcess</pre>
</li>
</ul>
<a name="fileChooser">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>fileChooser</h4>
<pre>final&nbsp;javafx.stage.FileChooser fileChooser</pre>
<div class="block">File chooser for pick the text file with the math expressions</div>
</li>
</ul>
<a name="myParser">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>myParser</h4>
<pre>private static&nbsp;<a href="MyParser.html" title="class in &lt;Unnamed&gt;">MyParser</a> myParser</pre>
<div class="block">For parse</div>
</li>
</ul>
<a name="numericFunctionSet">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>numericFunctionSet</h4>
<pre>private static&nbsp;java.util.HashSet&lt;java.lang.String&gt; numericFunctionSet</pre>
<div class="block">A hashSet to store the numericFunctionSet</div>
</li>
</ul>
<a name="keywords">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>keywords</h4>
<pre>private static&nbsp;java.util.HashSet&lt;java.lang.String&gt; keywords</pre>
<div class="block">A HashSet used to store the keywords from lisp</div>
</li>
</ul>
<a name="funArgumentsList">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>funArgumentsList</h4>
<pre>private static&nbsp;java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt; funArgumentsList</pre>
</li>
</ul>
<a name="funDefinitionList">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>funDefinitionList</h4>
<pre>private static&nbsp;java.util.LinkedList&lt;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt; funDefinitionList</pre>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="LispInterpreterView--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>LispInterpreterView</h4>
<pre>public&nbsp;LispInterpreterView()</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="show-javafx.stage.Stage-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>show</h4>
<pre>public&nbsp;void&nbsp;show(javafx.stage.Stage&nbsp;stage)</pre>
<div class="block">To show the JavFX UI</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>stage</code> - Stage of JavaFX where we're gonna render the UI</dd>
</dl>
</li>
</ul>
<a name="addHBox-javafx.stage.Stage-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addHBox</h4>
<pre>public&nbsp;javafx.scene.layout.HBox&nbsp;addHBox(javafx.stage.Stage&nbsp;stage)</pre>
<div class="block">To return a HBox with two buttons for read file and clear TextArea</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>stage</code> - Stage of JavaFX where we're gonna render the UI</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a filled HBox to add to the UI</dd>
</dl>
</li>
</ul>
<a name="hasSameBraces-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasSameBraces</h4>
<pre>private&nbsp;boolean&nbsp;hasSameBraces(java.lang.String&nbsp;line)</pre>
<div class="block">Verifies if an expression has the same amount of opening braces as closing braces before passing the expression
 to the execution part</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>line</code> - a String representing the line with a expression</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the amount of leftSide and rigth braces is equal, false otherwise</dd>
</dl>
</li>
</ul>
<a name="readFile-java.io.File-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>readFile</h4>
<pre>private&nbsp;java.util.ArrayList&lt;java.lang.String&gt;&nbsp;readFile(java.io.File&nbsp;file)</pre>
<div class="block">For read a file line by line</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>file</code> - File object which have the math operation</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an ArrayList of String lines of the file</dd>
</dl>
</li>
</ul>
<a name="addVBox--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addVBox</h4>
<pre>public&nbsp;javafx.scene.layout.VBox&nbsp;addVBox()</pre>
<div class="block">For add a TextArea to the screen, and show the result</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a filled HBox to add to the UI</dd>
</dl>
</li>
</ul>
<a name="startInterpreting--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>startInterpreting</h4>
<pre>public&nbsp;void&nbsp;startInterpreting()
                       throws java.lang.Exception</pre>
<div class="block">Interpreting the expression</div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if it can´t be evaluated</dd>
</dl>
</li>
</ul>
<a name="getExpression-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExpression</h4>
<pre>private static&nbsp;java.lang.String&nbsp;getExpression(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;root)
                                       throws java.lang.Exception</pre>
<div class="block">Gets the expression as a String</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>root</code> - the root node of the tree</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the String of the expression</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if it is unparseable</dd>
</dl>
</li>
</ul>
<a name="printExpression-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>printExpression</h4>
<pre>private&nbsp;void&nbsp;printExpression(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;root)
                      throws java.lang.Exception</pre>
<div class="block">Pretty printing the parse tree for top-level expression</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>root</code> - the root Node, to start printing</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if it can´t be printed</dd>
</dl>
</li>
</ul>
<a name="isList-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isList</h4>
<pre>private static&nbsp;boolean&nbsp;isList(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;node)</pre>
<div class="block">verify if a given Node is a list</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - the node to analize</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if node.value.equals "T" a</dd>
</dl>
</li>
</ul>
<a name="length-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>length</h4>
<pre>private static&nbsp;int&nbsp;length(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;node)</pre>
<div class="block">Check the length of a node</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - the Node type oject to evaluate</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an int 0 = no, 1 = yeah</dd>
</dl>
</li>
</ul>
<a name="numNodes-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>numNodes</h4>
<pre>private static&nbsp;int&nbsp;numNodes(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;node)</pre>
<div class="block">Calculat the number of nodes that are childs of an specific Node</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - the node to AnalYze</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>returns the num of Nodes</dd>
</dl>
</li>
</ul>
<a name="car-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>car</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;car(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)
                 throws java.lang.Exception</pre>
<div class="block">Checks if a given Node has a leftSide child.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s</code> - the node to analyze</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the leftSide Node in case the original node s has a Token</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd>
</dl>
</li>
</ul>
<a name="cdr-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cdr</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;cdr(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)
                 throws java.lang.Exception</pre>
<div class="block">Evaluates the rightSide child of a Node</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s</code> - the node to evaluate</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the Node that it is immediately to the rightSide</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd>
</dl>
</li>
</ul>
<a name="cons-Node-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cons</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;cons(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
                         <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)</pre>
<div class="block">Constructs a new pair of variables from any type (ATOM_NUMBER, ATOM_LITERAL)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s1</code> - first Node to add to the Pair</dd>
<dd><code>s2</code> - second Node to add to the Pair</dd>
<dt><span class="returnLabel">Returns:</span></dt>
</dl>
</li>
</ul>
<a name="atom-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>atom</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;atom(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</pre>
<div class="block">Verifies if an specific argument passed after atom is ATOM type or not</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s</code> - the node to verify if it is atom</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the new value for atom (true = T)</dd>
</dl>
</li>
</ul>
<a name="isLiteralAtom-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isLiteralAtom</h4>
<pre>private static&nbsp;boolean&nbsp;isLiteralAtom(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</pre>
<div class="block">Verifies if a certain node is LiteralAtom type</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s</code> - the node to evaluate, with a value and a type</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the value is between 'A' and 'Z', false otherwise</dd>
</dl>
</li>
</ul>
<a name="int_-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>int_</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;int_(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</pre>
<div class="block">Evaluates if a given node is int type (creates a new Node of value T or NIL depending on wether
 it is or not an int type Node)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s</code> - the Node to evaluate</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a new node, from not Inner type with value T or NIL</dd>
</dl>
</li>
</ul>
<a name="string_-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>string_</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;string_(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</pre>
<div class="block">Evaluates if a given node is string type (creates a new Node of value T or NIL depending on whether
 it is or not a string type Node)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s</code> - the node to evaluate</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a Node with value T if the nodes does not have leftSide or rightSide nodes and contains \,NIL otherwise</dd>
</dl>
</li>
</ul>
<a name="null_-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>null_</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;null_(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s)</pre>
<div class="block">Evaluates if a node's value is NIL type</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s</code> - Node to evaluate</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a new with value T if param.value is equal to NIL and param does not have leftSide or rightSide nodes, NIL otherwise</dd>
</dl>
</li>
</ul>
<a name="eq-Node-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>eq</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;eq(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
                       <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)
                throws java.lang.Exception</pre>
<div class="block">Verifies if the value of a node is equal to the value of another node</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s1</code> - first node to compare</dd>
<dd><code>s2</code> - second node to compare</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>instance of a Node with value T if the or NIL</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if one or both nodes have more than one node (they´re not a single ATOM value)</dd>
</dl>
</li>
</ul>
<a name="plus-Node-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>plus</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;plus(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
                         <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)
                  throws java.lang.Exception</pre>
<div class="block">Sums the value of two NumericAtom type nodes</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s1</code> - the first node to sum</dd>
<dd><code>s2</code> - the second node to sum</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>instance of a Node with the value of the sum</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if one or both nodes have more than one node (they´re not a single ATOM value)</dd>
</dl>
</li>
</ul>
<a name="minus-Node-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>minus</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;minus(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
                          <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)
                   throws java.lang.Exception</pre>
<div class="block">Operates a rest with the value of two NumericAtom type nodes</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s1</code> - the minuend of the operation</dd>
<dd><code>s2</code> - the substract of the operation</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>instance of a Node with the result of the rest</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if one or both nodes have more than one node (they´re not a single ATOM value)</dd>
</dl>
</li>
</ul>
<a name="times-Node-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>times</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;times(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
                          <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)
                   throws java.lang.Exception</pre>
<div class="block">Multiplies two NumericAtom type nodes</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s1</code> - the first operand</dd>
<dd><code>s2</code> - the second operand</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>instance of a Node with the result of the multiplication</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if one or both nodes have more than one node (they´re not a single ATOM value)</dd>
</dl>
</li>
</ul>
<a name="quotient-Node-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>quotient</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;quotient(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
                             <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)
                      throws java.lang.Exception</pre>
<div class="block">Operates the division between two NumericAtom type nodes</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s1</code> - the dividend of the operation</dd>
<dd><code>s2</code> - the divisor of the operation</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>instance of a Node with the quotient of the division as the value</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if one or both nodes have more than one node (they´re not a single ATOM value)</dd>
</dl>
</li>
</ul>
<a name="remainder-Node-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>remainder</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;remainder(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
                              <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)
                       throws java.lang.Exception</pre>
<div class="block">Operates a division between two NumericAtom type nodes and returns the reminder of the operation</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s1</code> - the dividend of the operation</dd>
<dd><code>s2</code> - the divisor of the operation</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>instance of a Node with the remainder of the division as the value</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if one or both nodes have more than one node (they´re not a single ATOM value)</dd>
</dl>
</li>
</ul>
<a name="less-Node-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>less</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;less(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
                         <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)
                  throws java.lang.Exception</pre>
<div class="block">Verifies if the value of node 1 is less than value of node 2</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s1</code> - allegedly minor node</dd>
<dd><code>s2</code> - allegedly greater node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>T if value of s1 is minor than value of s2, NIL otherwise</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if one or both nodes have more than one node (they´re not a single ATOM value)</dd>
</dl>
</li>
</ul>
<a name="greater-Node-Node-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>greater</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;greater(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s1,
                            <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s2)
                     throws java.lang.Exception</pre>
<div class="block">Verifies if the value of node 1 is greater than value of node 2</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s1</code> - allegedly greater node</dd>
<dd><code>s2</code> - allegedly minor node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>T if value of s1 is greater than value of s2, NIL otherwise</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if one or both nodes have more than one node (they´re not a single ATOM value)</dd>
</dl>
</li>
</ul>
<a name="bound-java.lang.String-java.util.LinkedList-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>bound</h4>
<pre>private static&nbsp;boolean&nbsp;bound(java.lang.String&nbsp;key,
                             java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList)</pre>
<div class="block">Search in a Node HashMap contains a pair with a given key</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key to search in the Node HashMap</dd>
<dd><code>aList</code> - the funArgumentsList that saves the pair of params from the function</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if pair is found, false otherwise</dd>
</dl>
</li>
</ul>
<a name="getVal-java.lang.String-java.util.LinkedList-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getVal</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;getVal(java.lang.String&nbsp;key,
                           java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList)</pre>
<div class="block">Gets a node from the funArgumentsList linkedList with an specific key provided</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>key</code> - the key of the Node to get</dd>
<dd><code>aList</code> - the funArgumentsList that saves the pair of params from the function</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the Node if funArgumentsList contains it or null otherwise</dd>
</dl>
</li>
</ul>
<a name="getValFromDList-java.lang.String-java.util.LinkedList-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getValFromDList</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;getValFromDList(java.lang.String&nbsp;functionName,
                                    java.util.LinkedList&lt;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&nbsp;dList)
                             throws java.lang.Exception</pre>
<div class="block">Obtains the Node that contains a function definition matching a given functionName</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>functionName</code> - the name of the function as String</dd>
<dd><code>dList</code> - the LinkedList that contains the Node with the function</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The definition of the function</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if the function doesn't exists in the funDefinitionList</dd>
</dl>
</li>
</ul>
<a name="apply-Node-Node-java.util.LinkedList-java.util.LinkedList-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>apply</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;apply(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;funName,
                          <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;actualParamList,
                          java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList,
                          java.util.LinkedList&lt;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&nbsp;dList)
                   throws java.lang.Exception</pre>
<div class="block">applies the changes and executes the function</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>funName</code> - the node that represents the function</dd>
<dd><code>actualParamList</code> - Node that contains the parameters of the function</dd>
<dd><code>aList</code> - the list that contains the actual parameters of a function Definition</dd>
<dd><code>dList</code> - the list that contains the functions as Nodes</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the node of the evaluated function</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd>
</dl>
</li>
</ul>
<a name="addPairs-Node-Node-java.util.LinkedList-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addPairs</h4>
<pre>private static&nbsp;void&nbsp;addPairs(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;formalParamList,
                             <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;actualParamList,
                             java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList)
                      throws java.lang.Exception</pre>
<div class="block">Adds the Node of the required param for a function and the Node of the passed params tho the funArgumentsList</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>formalParamList</code> - the Node object that contains the required params for the function</dd>
<dd><code>actualParamList</code> - the Node object that contains the given params for the function</dd>
<dd><code>aList</code> - the LinkedList that saves the pairs of the nodes specified above</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd>
</dl>
</li>
</ul>
<a name="removePairs-Node-Node-java.util.LinkedList-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removePairs</h4>
<pre>private static&nbsp;void&nbsp;removePairs(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;formalParamList,
                                <a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;actualParamList,
                                java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList)
                         throws java.lang.Exception</pre>
<div class="block">Deletes the pairs from funArgumentsList once the function is executed</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>formalParamList</code> - the Node object that contains the required params for the function</dd>
<dd><code>actualParamList</code> - the Node object that contains the given params for the function</dd>
<dd><code>aList</code> - the LinkedList that saves the pairs of the nodes specified above</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code></dd>
</dl>
</li>
</ul>
<a name="evList-Node-java.util.LinkedList-java.util.LinkedList-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>evList</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;evList(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;actualParamList,
                           java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList,
                           java.util.LinkedList&lt;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&nbsp;dList)
                    throws java.lang.Exception</pre>
<div class="block">Passes the constructed expression to the evaluate() method</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>actualParamList</code> - the Node object that contains the required params for the function</dd>
<dd><code>aList</code> - the LinkedList that saves the pairs of the nodes specified above</dd>
<dd><code>dList</code> - the LinkedList that contains the Node of the currentFunction</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the actualParamList if value of it is null, otherwise it returns the constructed expression Node already evaluated</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if it cannot construct and evaluate the expression</dd>
</dl>
</li>
</ul>
<a name="evaluate-Node-java.util.LinkedList-java.util.LinkedList-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>evaluate</h4>
<pre>private static&nbsp;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;evaluate(<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&nbsp;s,
                             java.util.LinkedList&lt;java.util.HashMap&lt;java.lang.String,<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&gt;&nbsp;aList,
                             java.util.LinkedList&lt;<a href="Node.html" title="class in &lt;Unnamed&gt;">Node</a>&gt;&nbsp;dList)
                      throws java.lang.Exception</pre>
<div class="block">Evaluates a node (function), both UDF´s and proper Lisp functions are evaluated and changes are made callin apply() method</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>s</code> - Node to evaluate</dd>
<dd><code>aList</code> - the LinkedList that saves the pairs of the actual and given params to a function type node</dd>
<dd><code>dList</code> - LinkedList that contains the Functions Nodes</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the resulting Node of the expression or function</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.lang.Exception</code> - if the expression is from undefined type, if it is not a list, if there are to many arguments to a given function,
                   if there are to few arguments to the function, if an arithmetic function is called with LITERAL_ATOM type or T or NIL.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="deprecated-list.html">Deprecated</a></li>
<li><a href="index-files/index-1.html">Index</a></li>
<li><a href="help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="Main.html" title="class in &lt;Unnamed&gt;"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="index.html?LispInterpreterView.html" target="_top">Frames</a></li>
<li><a href="LispInterpreterView.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
